<?php
session_start();
require dirname(__FILE__) . "/vendor/autoload.php";

$CONTENTTYPES = ["article" => "Article", "longform" => "LongForm", "video" => "Video", "audio" => "Audio"];
$LANGUAGES = [
  "en" => "English",
  'fr' => "French",
  'es' => "Spanish",
  'ge' => "German",
  'ja' => "Japanese",
  'zh' => "Chinese",
  'other' => "Other"
];
$SUBSCRIBERS = [
  '1' => '0-100',
  '100' => '100+',
  '500' => '500+',
  '1000' => '1000+',
  '10000' => '10000+'
];
$VELOCITY = [
  '1' => '0-10',
  '10' => '10+',
  '20' => '20+',
  '40' => '40+',
  '60' => '60+'
];
$UPDATES = [
  'today' => 'Today',
  'yesterday' => 'Yesterday',
  '1w' => 'Last Week',
  '1m' => 'Last Month',
  '6m' => 'Past 6 Months',
  'all' => 'All'
];

function ar_contents($campaignId) {
  global $CONTENTTYPES, $LANGUAGES, $VELOCITY, $UPDATES, $SUBSCRIBERS;

  if (!empty($_POST['arSearchFeed'])) {
    if (empty($_POST['keyword'])) {
      $_SESSION["AR_FEEDLY_SEARCH_${campaignId}"] = null;
      $_SESSION["AR_RESPONSES_${campaignId}"] = null;
    }
    else {
      $accesstoken = get_post_meta('111111119', $campaignId . 'accesstoken', TRUE);
      $client = new feedly\HTTPClient();

      $client->setCustomHeader(array(
        "Authorization: OAuth " . $accesstoken,
        'Content-Type: application/json'
      ));

      $response = $client->get('https://cloud.feedly.com' . '/v3/search/feeds?count=500&query=' . urlencode(trim($_POST['keyword'])));

      $_SESSION["AR_FEEDLY_SEARCH_${campaignId}"] = $_POST['keyword'];
      $_SESSION["AR_RESPONSES_${campaignId}"] = $response['results'];
      $_SESSION["AR_FILTERS_${campaignId}"] = array(
        'contentType' => array_keys($CONTENTTYPES),
        'language' => array_keys($LANGUAGES),
        'velocity' => array_keys($VELOCITY),
        'lastUpdated' => array_keys($UPDATES),
        'subscribers' => array_keys($SUBSCRIBERS)
      );
    }
  }

  if (!empty($_POST['arFilterFeed'])) {
    $_SESSION["AR_FILTERS_${campaignId}"] = array(
      'contentType' => $_POST['contentType'],
      'language' => $_POST['language'],
      'velocity' => $_POST['velocity'],
      'lastUpdated' => $_POST['updates'],
      'subscribers' => $_POST['subscribers']
    );
  }

  global $wpdb;
  $table_name = $wpdb->prefix . "arp_feeds";

  if ($_POST['action'] === 'store') {
    foreach ($_POST['content'] as $input) {
    	foreach ($_SESSION["AR_RESPONSES_${campaignId}"] as $feed) {
    		if ($feed['feedId'] === $input) {
    			break;
    		}
    	}

    	if (!empty($feed)) {
        // $rowcount = $wpdb->get_var("SELECT COUNT(*) FROM $table_name where campaign_id=${campaignId}");
        // if ($rowcount < 10) {
    		$wpdb->insert($table_name, array(
    			'title' => $feed['title'],
    			'campaign_id' => $campaignId,
    			'website' => substr($feed['feedId'], 5),
    			'lastUpdated' => $feed['lastUpdated'],
    			'contentType' => $feed['contentType'],
    			'language' => $feed['language'],
    			'velocity' => $feed['velocity'],
    			'subscribers' => $feed['subscribers'],
    			'iconUrl' => $feed['iconUrl'],
    			'description' => $feed['description']
    		));
        // } else {
        //   $message = "Cannot add more than 10 feeds";
        // }
    	}
    }
  }

  // if (!empty($message)) {
  //   echo "<div style='color: red'>" . $message . "</div>";
  // }

  echo '<div><h3>My Content Sources</h3><form id="storedata" name="storeddata" method="post" action="">';
  $wp_list_table1 = new ARFeeds($campaignId);
  $wp_list_table1->prepare_items();
  $wp_list_table1->display();

  echo '</form></div>';

  echo '<hr style="margin-bottom: 30px; margin-top: 30px;" /><div>
    <h3>Find Content Sources</h3>
		<form method="post" action="">
  		<table style="width: 100%">
  			<tr>
          <td style="width: 160px">Enter Keyword:</td>
          <td>
            <input type="text" name="keyword" size="50" value="'.$_SESSION["AR_FEEDLY_SEARCH_${campaignId}"].'">
            <input name="arSearchFeed" type="submit" value="Search" class="button button-primary" />
          </td>
        </tr>
  		</table>
		</form>

    <form method="post" action="">
    <fieldset style="background-color: white; padding: 15px; border: 1px solid #ccc;">
      <legend>Filter</legend>
  		<table style="width: 100%">
  			<tr>
          <td style="width: 160px">Content Type:</td>
          <td>';
              foreach($CONTENTTYPES as $ct => $lbl) {
                echo '<label style="margin-right: 10px;">';
                if (in_array($ct, $_SESSION["AR_FILTERS_${campaignId}"]['contentType'])) {
                  echo '<input type="checkbox" name="contentType[]" value="'.$ct.'" checked>'.$lbl;
                } else {
                  echo '<input type="checkbox" name="contentType[]" value="'.$ct.'">'.$lbl;
                }
                echo '</label>';
              }
          echo '</td></tr><tr>
          <td style="width: 160px">Language:</td>
          <td>';
          foreach($LANGUAGES as $ct => $lbl) {
            echo '<label style="margin-right: 10px;">';
            if (in_array($ct, $_SESSION["AR_FILTERS_${campaignId}"]['language'])) {
              echo '<input type="checkbox" name="language[]" value="'.$ct.'" checked>'.$lbl;
            } else {
              echo '<input type="checkbox" name="language[]" value="'.$ct.'">'.$lbl;
            }
            echo '</label>';
          }
          echo '</td></tr><tr>
          <td style="width: 160px">Velocity:</td>
          <td>';
          foreach($VELOCITY as $ct => $lbl) {
            echo '<label style="margin-right: 10px;">';
            if (in_array($ct, $_SESSION["AR_FILTERS_${campaignId}"]['velocity'])) {
              echo '<input type="checkbox" name="velocity[]" value="'.$ct.'" checked>'.$lbl;
            } else {
              echo '<input type="checkbox" name="velocity[]" value="'.$ct.'">'.$lbl;
            }
            echo '</label>';
          }
          echo '</td></tr><tr>
          <td style="width: 160px">Last Updated:</td>
          <td>';
          foreach($UPDATES as $ct => $lbl) {
            echo '<label style="margin-right: 10px;">';
            if (in_array($ct, $_SESSION["AR_FILTERS_${campaignId}"]['lastUpdated'])) {
              echo '<input type="checkbox" name="updates[]" value="'.$ct.'" checked>'.$lbl;
            } else {
              echo '<input type="checkbox" name="updates[]" value="'.$ct.'">'.$lbl;
            }
            echo '</label>';
          }
          echo '</td></tr><tr>
          <td style="width: 160px">Subscribers:</td>
          <td>';
          foreach($SUBSCRIBERS as $ct => $lbl) {
            echo '<label style="margin-right: 10px;">';
            if (in_array($ct, $_SESSION["AR_FILTERS_${campaignId}"]['subscribers'])) {
              echo '<input type="checkbox" name="subscribers[]" value="'.$ct.'" checked>'.$lbl;
            } else {
              echo '<input type="checkbox" name="subscribers[]" value="'.$ct.'">'.$lbl;
            }
            echo '</label>';
          }
          echo '</td>
        </tr>
  		</table>
      <input name="arFilterFeed" type="submit" value="Filter" class="button button-primary" />
		</form>
	</div>
  <form id="searchdata" name="searchdata" method="post" action="">';
    $wp_list_table2 = new ARFeedly(
      array_filter(
        $_SESSION["AR_RESPONSES_${campaignId}"],
        function ($row) use($campaignId) {
          $filters = $_SESSION["AR_FILTERS_${campaignId}"];

          foreach ($filters['contentType'] as $filter) {
            $contentType = $contentType || $row['contentType'] == $filter;
          }

          foreach ($filters['language'] as $filter) {
            $language = $language || (
              $filter !== 'other'
              ? $row['language'] == $filter
              : !in_array(
                $row['language'], ['en', 'fr', 'ge', 'es', 'ja', 'zh']
              )
            );
          }

          foreach ($filters['lastUpdated'] as $filter) {
            if ($filter == 'today') {
              $updates = $updates || date('Y-m-d') == date('Y-m-d', $row['lastUpdated'] / 1000);
            } else if ($filter == 'yesterday') {
              $updates = $updates || date('Y-m-d', strtotime('-1 days')) == date('Y-m-d', $row['lastUpdated'] / 1000);
            } else if ($filter == '1w') {
              $updates = $updates || (($row['lastUpdated'] / 1000) - strtotime('-1 weeks')) > 0;
            } else if ($filter == '1m') {
              $updates = $updates || (($row['lastUpdated'] / 1000) - strtotime('-1 months')) > 0;
            } else if ($filter == '6m') {
              $updates = $updates || (($row['lastUpdated'] / 1000) - strtotime('-6 months')) > 0;
            } else if ($filter == 'all') {
              $updates = $updates || true;
            }
          }

          foreach ($filters['subscribers'] as $filter) {
            if ($filter == '1') {
              $subscribers = $subscribers || ($row['subscribers'] < 100);
            } else if ($filter == '100') {
              $subscribers = $subscribers || ($row['subscribers'] >= 100 && $row['subscribers'] < 500);
            } else if ($filter == '500') {
              $subscribers = $subscribers || ($row['subscribers'] >= 500 && $row['subscribers'] < 1000);
            } else if ($filter == '1000') {
              $subscribers = $subscribers || ($row['subscribers'] >= 1000 && $row['subscribers'] < 10000);
            } else if ($filter == '10000') {
              $subscribers = $subscribers || ($row['subscribers'] >= 10000);
            }
          }

          foreach ($filters['velocity'] as $filter) {
            if ($filter == 1) {
              $velocity = $velocity || ($row['velocity'] >= 0 && $row['velocity'] < 10);
            } else if ($filter == 10) {
              $velocity = $velocity || ($row['velocity'] >= 10 && $row['velocity'] < 20);
            } else if ($filter == 20) {
              $velocity = $velocity || ($row['velocity'] >= 20 && $row['velocity'] < 40);
            } else if ($filter == 40) {
              $velocity = $velocity || ($row['velocity'] >= 40 && $row['velocity'] < 60);
            } else if ($filter == 60) {
              $velocity = $velocity || $row['velocity'] >= 60;
            }
          }

          return $contentType && $language && $updates && $subscribers && $velocity;
        }
      )
    );
    $wp_list_table2->prepare_items();
    $wp_list_table2->display();
  echo '</form></div>';
}
